(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@mavrykdynamics/taquito'), require('child_process'), require('fs')) :
    typeof define === 'function' && define.amd ? define(['exports', '@mavrykdynamics/taquito', 'child_process', 'fs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.createLambdaBytes = {}, global.taquito, global.child_process, global.fs));
})(this, (function (exports, taquito, child_process, fs) { 'use strict';

    function _interopNamespaceDefault(e) {
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n.default = e;
        return Object.freeze(n);
    }

    var fs__namespace = /*#__PURE__*/_interopNamespaceDefault(fs);

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise, SuppressedError, Symbol */


    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
        var e = new Error(message);
        return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
    };

    const proxyContract = (lambdaFunction) => {
        return `// ------------------------------------------------------------------------------
// Types
// ------------------------------------------------------------------------------

type setLambdaType is [@layout:comb] record [
    name                  : string;
    func_bytes            : bytes;
]
type farmTypeType is 
        Farm    of unit
    |   MFarm   of unit
type setFarmLambdaType is [@layout:comb] record [
    name                  : string;
    func_bytes            : bytes;
    farmType              : farmTypeType;
]

type updateMetadataType is [@layout:comb] record [
    metadataKey      : string;
    metadataHash     : bytes; 
]

type updateType is 
    |   Update of unit
    |   Remove of unit

type updateWhitelistContractsType is [@layout:comb] record [
    whitelistContractAddress  : address;
    updateType                : updateType;
]

type updateGeneralContractsType is [@layout:comb] record [
    generalContractName     : string;
    generalContractAddress  : address;
    updateType              : updateType;
]

type updateWhitelistTokenContractsType is [@layout:comb] record [
    tokenContractAddress  : address;
    updateType            : updateType;
]

type aggregatorUpdateConfigActionType is 
        ConfigDecimals                      of unit
    |   ConfigAlphaPercentPerThousand       of unit

    |   ConfigPercentOracleThreshold        of unit
    |   ConfigHeartbeatSeconds              of unit

    |   ConfigRewardAmountStakedMvn         of unit
    |   ConfigRewardAmountXtz               of unit

type aggregatorUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue  : nat; 
    updateConfigAction    : aggregatorUpdateConfigActionType;
]

type aggregatorFactoryUpdateConfigActionType is 
    | ConfigAggregatorNameMaxLength   of unit
    | Empty                           of unit

type aggregatorFactoryUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue  : nat; 
    updateConfigAction    : aggregatorFactoryUpdateConfigActionType;
]

type breakGlassUpdateConfigActionType is 
        ConfigThreshold               of unit
    |   ConfigActionExpiryDays        of unit
    |   ConfigCouncilNameMaxLength    of unit
    |   ConfigCouncilWebsiteMaxLength of unit
    |   ConfigCouncilImageMaxLength   of unit

type breakGlassUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue  : nat; 
    updateConfigAction    : breakGlassUpdateConfigActionType;
]

type councilUpdateConfigActionType is 
        ConfigThreshold                       of unit
    |   ConfigActionExpiryDays                of unit
    |   ConfigCouncilNameMaxLength            of unit
    |   ConfigCouncilWebsiteMaxLength         of unit
    |   ConfigCouncilImageMaxLength           of unit
    |   ConfigRequestTokenNameMaxLength       of unit
    |   ConfigRequestPurposeMaxLength         of unit

type councilUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue        : nat; 
    updateConfigAction          : councilUpdateConfigActionType;
]

type delegationUpdateConfigActionType is 
        ConfigMinimumStakedMvnBalance of unit
    |   ConfigDelegationRatio         of unit
    |   ConfigMaxSatellites           of unit
    |   ConfigSatNameMaxLength        of unit
    |   ConfigSatDescMaxLength        of unit
    |   ConfigSatImageMaxLength       of unit
    |   ConfigSatWebsiteMaxLength     of unit

type delegationUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue    : nat; 
    updateConfigAction      : delegationUpdateConfigActionType;
]

type doormanUpdateConfigActionType is 
        ConfigMinMvnAmount          of unit
    |   Empty                       of unit

type doormanUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue    : nat; 
    updateConfigAction      : doormanUpdateConfigActionType;
]

type emergencyUpdateConfigActionType is 
        ConfigDurationInMinutes         of unit
    |   ConfigRequiredFeeMutez          of unit
    |   ConfigStakedMvnPercentRequired  of unit
    |   ConfigMinStakedMvnForVoting     of unit
    |   ConfigMinStakedMvnToTrigger     of unit
    |   ConfigProposalTitleMaxLength    of unit
    |   ConfigProposalDescMaxLength     of unit

type emergencyUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue  : nat; 
    updateConfigAction    : emergencyUpdateConfigActionType;
]

type farmUpdateConfigActionType is 
        ConfigForceRewardFromTransfer of unit
    |   ConfigRewardPerBlock of unit
type farmUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue    : nat; 
    updateConfigAction      : farmUpdateConfigActionType;
]

type farmFactoryUpdateConfigActionType is 
        ConfigFarmNameMaxLength of unit
    |   Empty                   of unit

type farmFactoryUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue    : nat; 
    updateConfigAction      : farmFactoryUpdateConfigActionType;
]

type governanceUpdateConfigActionType is 
        ConfigSuccessReward               of unit
    |   ConfigCycleVotersReward           of unit
    |   ConfigMinProposalRoundVotePct     of unit
    |   ConfigMinQuorumPercentage         of unit
    |   ConfigMinYayVotePercentage        of unit
    |   ConfigProposeFeeMumav             of unit
    |   ConfigMaxProposalsPerSatellite    of unit
    |   ConfigBlocksPerProposalRound      of unit
    |   ConfigBlocksPerVotingRound        of unit
    |   ConfigBlocksPerTimelockRound      of unit
    |   ConfigDataTitleMaxLength          of unit
    |   ConfigProposalTitleMaxLength      of unit
    |   ConfigProposalDescMaxLength       of unit
    |   ConfigProposalInvoiceMaxLength    of unit
    |   ConfigProposalCodeMaxLength       of unit

type governanceUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue    : nat; 
    updateConfigAction      : governanceUpdateConfigActionType;
]

type governanceFinancialUpdateConfigActionType is
    |   ConfigApprovalPercentage          of unit
    |   ConfigFinancialReqDurationDays    of unit

type governanceFinancialUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue    : nat; 
    updateConfigAction      : governanceFinancialUpdateConfigActionType;
]

type governanceSatelliteUpdateConfigActionType is 
        ConfigApprovalPercentage          of unit
    |   ConfigActionDurationInDays        of unit
    |   ConfigPurposeMaxLength            of unit
    |   ConfigMaxActionsPerSatellite      of unit

type governanceSatelliteUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue  : nat; 
    updateConfigAction    : governanceSatelliteUpdateConfigActionType;
]

type lendingControllerUpdateConfigActionType is 
        ConfigCollateralRatio           of unit
    |   ConfigLiquidationRatio          of unit
    |   ConfigLiquidationFeePercent     of unit
    |   ConfigAdminLiquidationFee       of unit
    |   ConfigMinimumLoanFeePercent     of unit
    |   ConfigMinLoanFeeTreasuryShare   of unit
    |   ConfigInterestTreasuryShare     of unit
    |   ConfigLastCompletedDataMaxDelay of unit
    |   ConfigMaxVaultLiqPercent        of unit
    |   ConfigLiquidationDelayInMins    of unit
    |   ConfigLiquidationMaxDuration    of unit

type lendingControllerUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue    : nat;  
    updateConfigAction      : lendingControllerUpdateConfigActionType;
]

type treasuryFactoryUpdateConfigActionType is 
        ConfigTreasuryNameMaxLength of unit
    |   Empty                       of unit
type treasuryFactoryUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue    : nat; 
    updateConfigAction      : treasuryFactoryUpdateConfigActionType;
]

type vaultFactoryUpdateConfigActionType is 
    |   ConfigVaultNameMaxLength of unit
    |   Empty                    of unit

type vaultFactoryUpdateConfigParamsType is [@layout:comb] record [
    updateConfigNewValue    : nat; 
    updateConfigAction      : vaultFactoryUpdateConfigActionType;
]

type aggregatorPausableEntrypointType is
        UpdateData                    of bool
    |   WithdrawRewardXtz             of bool
    |   WithdrawRewardStakedMvn       of bool

type aggregatorTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint  : aggregatorPausableEntrypointType;
    empty             : unit
];

type aggregatorFactoryPausableEntrypointType is
        CreateAggregator            of bool
    |   UntrackAggregator           of bool
    |   TrackAggregator             of bool
    |   DistributeRewardXtz         of bool
    |   DistributeRewardStakedMvn   of bool

type aggregatorFactoryTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint      : aggregatorFactoryPausableEntrypointType;
    empty                 : unit
];

type delegationPausableEntrypointType is
        DelegateToSatellite             of bool
    |   UndelegateFromSatellite         of bool
    |   RegisterAsSatellite             of bool
    |   UnregisterAsSatellite           of bool
    |   UpdateSatelliteRecord           of bool
    |   DistributeReward                of bool
    |   TakeSatellitesSnapshot          of bool

type delegationTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint  : delegationPausableEntrypointType;
    empty             : unit
];

type doormanPausableEntrypointType is
        StakeMvn                      of bool
    |   UnstakeMvn                    of bool
    |   Exit                          of bool
    |   Compound                      of bool
    |   FarmClaim                     of bool
    |   OnVaultDepositStake           of bool
    |   OnVaultWithdrawStake          of bool
    |   OnVaultLiquidateStake         of bool

type doormanTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint  : doormanPausableEntrypointType;
    empty             : unit
];

type farmPausableEntrypointType is
        Deposit     of bool
    |   Withdraw    of bool
    |   Claim       of bool

type farmTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint  : farmPausableEntrypointType;
    empty             : unit
];

type farmFactoryPausableEntrypointType is
        CreateFarm         of bool
    |   CreateFarmMToken   of bool
    |   UntrackFarm        of bool
    |   TrackFarm          of bool

type farmFactoryTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint  : farmFactoryPausableEntrypointType;
    empty             : unit
];

type lendingControllerPausableEntrypointType is

        // Lending Controller Admin Entrypoints
    |   SetLoanToken                of bool
    |   SetCollateralToken          of bool

        // Lending Controller Token Pool Entrypoints
    |   AddLiquidity                of bool
    |   RemoveLiquidity             of bool

        // Lending Controller Vault Entrypoints
    |   RegisterVaultCreation       of bool
    |   CloseVault                  of bool
    |   RegisterDeposit             of bool
    |   RegisterWithdrawal          of bool
    |   MarkForLiquidation          of bool
    |   LiquidateVault              of bool
    |   Borrow                      of bool
    |   Repay                       of bool

        // Vault Entrypoints
    |   VaultDeposit                of bool
    |   VaultWithdraw               of bool
    |   VaultOnLiquidate            of bool

        // Vault Staked Token Entrypoints
    |   VaultDepositStakedToken     of bool
    |   VaultWithdrawStakedToken    of bool

type lendingControllerTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint  : lendingControllerPausableEntrypointType;
    empty             : unit
];

type treasuryPausableEntrypointType is
        Transfer                       of bool   
    |   MintMvnAndTransfer             of bool
    |   UpdateTokenOperators           of bool
    |   StakeTokens                    of bool
    |   UnstakeTokens                  of bool

type treasuryTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint  : treasuryPausableEntrypointType;
    empty             : unit
];

type treasuryFactoryPausableEntrypointType is
        CreateTreasury         of bool
    |   TrackTreasury          of bool
    |   UntrackTreasury        of bool

type treasuryFactoryTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint  : treasuryFactoryPausableEntrypointType;
    empty             : unit
];

type vaultFactoryPausableEntrypointType is
    |   CreateVault         of bool  
    |   Empty               of unit 

type vaultFactoryTogglePauseEntrypointType is [@layout:comb] record [
    targetEntrypoint  : vaultFactoryPausableEntrypointType;
    empty             : unit
];

type lpStandardType is
        Fa12 of unit
    |   Fa2 of unit

type farmLpTokenType is [@layout:comb] record [
    tokenAddress             : address;
    tokenId                  : nat;
    tokenStandard            : lpStandardType;
]
type farmPlannedRewardsType is [@layout:comb] record[
    totalBlocks              : nat;
    currentRewardPerBlock    : nat;
]
type createFarmType is [@layout:comb] record[
    name                     : string;
    addToGeneralContracts    : bool;
    forceRewardFromTransfer  : bool;
    infinite                 : bool;
    plannedRewards           : farmPlannedRewardsType;
    metadata                 : bytes;
    lpToken                  : farmLpTokenType;
]
type createFarmMTokenType is [@layout:comb] record[
    name                     : string;
    loanToken                : string;
    addToGeneralContracts    : bool;
    forceRewardFromTransfer  : bool;
    infinite                 : bool;
    plannedRewards           : farmPlannedRewardsType;
    metadata                 : bytes;
    lpToken                  : farmLpTokenType;
]

type initFarmParamsType is [@layout:comb] record[
    totalBlocks                 : nat;
    currentRewardPerBlock       : nat;
    forceRewardFromTransfer     : bool;
    infinite                    : bool;
]

type createTreasuryType is [@layout:comb] record[
    baker                   : option(key_hash); 
    name                    : string;
    addToGeneralContracts   : bool;
    metadata                : bytes;
]

type mavType             is unit
type fa12TokenType       is address
type fa2TokenType        is [@layout:comb] record [
    tokenContractAddress    : address;
    tokenId                 : nat;
]
type tokenType is
    |   Mav    of mavType         // unit
    |   Fa12   of fa12TokenType   // address
    |   Fa2    of fa2TokenType    // record [ tokenContractAddress : address; tokenId : nat; ]

type transferDestinationType is [@layout:comb] record[
    to_       : address;
    amount    : nat;
    token     : tokenType;
]

type transferActionType is list(transferDestinationType);

type mintMvnAndTransferType is [@layout:comb] record [
    to_             : address;
    amt             : nat;
]

type operatorParameterType is [@layout:comb] record[
    owner       : address;
    operator    : address;
    token_id    : nat;
]
type updateOperatorVariantType is 
        Add_operator    of operatorParameterType
    |   Remove_operator of operatorParameterType
type updateOperatorsType is list(updateOperatorVariantType)
type updateTokenOperatorsType is [@layout:comb] record [
    tokenContractAddress    : address;
    updateOperators         : updateOperatorsType;
]
type stakeTokensType is [@layout:comb] record [
    contractAddress  : address;
    amount           : nat;
]
type unstakeTokensType is [@layout:comb] record [
    contractAddress  : address;
    amount           : nat;
]

type aggregatorConfigType is [@layout:comb] record [
    decimals                            : nat;
    alphaPercentPerThousand             : nat;

    percentOracleThreshold              : nat;
    heartbeatSeconds                    : nat;

    rewardAmountStakedMvn               : nat;
    rewardAmountXtz                     : nat;
];
type oracleInformationType is [@layout:comb] record [
    oraclePublicKey  : key;
    oraclePeerId     : string;
];
type oracleLedgerType            is map (address, oracleInformationType);
type createAggregatorParamsType is [@layout:comb] record[
    name                    : string;
    addToGeneralContracts   : bool;

    oracleLedger            : oracleLedgerType;
    
    aggregatorConfig        : aggregatorConfigType;
    metadata                : bytes;
];

type addVesteeType is [@layout:comb] record [
    vesteeAddress               : address;
    totalAllocatedAmount        : nat;
    cliffInMonths               : nat;
    vestingInMonths             : nat;
]

type updateVesteeType is [@layout:comb] record [
    vesteeAddress               : address;
    newTotalAllocatedAmount     : nat;
    newCliffInMonths            : nat;
    newVestingInMonths          : nat;
]

type createLoanTokenActionType is [@layout:comb] record [
    tokenName                               : string;
    tokenDecimals                           : nat;

    oracleAddress                           : address;

    mTokenAddress                           : address;

    reserveRatio                            : nat;  // percentage of token pool that should be kept as reserves for liquidity 
    optimalUtilisationRate                  : nat;  // kink point
    baseInterestRate                        : nat;  // base interest rate
    maxInterestRate                         : nat;  // max interest rate
    interestRateBelowOptimalUtilisation     : nat;  // interest rate below kink
    interestRateAboveOptimalUtilisation     : nat;  // interest rate above kink
    minRepaymentAmount                      : nat; 

    // variants at the end for taquito 
    tokenType                               : tokenType; 
]

type updateLoanTokenActionType is [@layout:comb] record [

    tokenName                               : string;

    oracleAddress                           : address;

    reserveRatio                            : nat;  // percentage of token pool that should be kept as reserves for liquidity 
    optimalUtilisationRate                  : nat;  // kink point
    baseInterestRate                        : nat;  // base interest rate
    maxInterestRate                         : nat;  // max interest rate
    interestRateBelowOptimalUtilisation     : nat;  // interest rate below kink
    interestRateAboveOptimalUtilisation     : nat;  // interest rate above kink
    minRepaymentAmount                      : nat; 

    isPaused                                : bool;
]

type setLoanTokenType is 
    |   CreateLoanToken      of createLoanTokenActionType
    |   UpdateLoanToken      of updateLoanTokenActionType

type setLoanTokenActionType is [@layout:comb] record [
    action      : setLoanTokenType;
    empty       : unit;
]

type createCollateralTokenActionType is [@layout:comb] record [
    tokenName               : string;
    tokenContractAddress    : address;
    tokenDecimals           : nat; 

    oracleAddress           : address;  
    protected               : bool;
    
    isScaledToken           : bool; // mToken
    
    // To extend functionality beyond sMVN to other staked tokens in future
    isStakedToken           : bool;
    stakingContractAddress  : option(address);

    maxDepositAmount        : option(nat);

    // variants at the end for taquito 
    tokenType               : tokenType; 
]

type updateCollateralTokenActionType is [@layout:comb] record [
    tokenName               : string;
    oracleAddress           : address;  
    isPaused                : bool;
    stakingContractAddress  : option(address);
    maxDepositAmount        : option(nat);
]

type setCollateralTokenType is 
    |   CreateCollateralToken      of createCollateralTokenActionType
    |   UpdateCollateralToken      of updateCollateralTokenActionType

type setCollateralTokenActionType is [@layout:comb] record [
    action      : setCollateralTokenType;
    empty       : unit;
]

type actionType is 
        // Default Entrypoint to Receive Mav
        Default                       of unit
    |   Empty                         of unit

const noOperations : list (operation) = nil;
type return is list (operation) * unit;

(* lamdda function *)
${lambdaFunction}

(* main entrypoint *)
function main (const action : actionType; const s : unit) : return is

    case action of [

            // Housekeeping Entrypoints
            Default (_parameters)                -> (lambdaFunction(), s)
        |   Empty (_parameters)                  -> ((nil : list(operation)), s)

    ]

;`;
    };
    const generateProxyContract = (lambdaFunctionName, lambdaFunctionParameters = []) => {
        // Create the function call
        var functionCall = lambdaFunctionName + "(";
        lambdaFunctionParameters.forEach((parameter) => {
            var formattedParameter = parameter;
            var parameterType = typeof (parameter);
            switch (parameterType) {
                case "string":
                    formattedParameter = `"${formattedParameter}"`;
                    break;
                case "object":
                    formattedParameter = (JSON.stringify(parameter));
                    break;
            }
            functionCall += formattedParameter + ",";
        });
        functionCall = functionCall.slice(0, -1) + ")";
        // Return the generated contract
        return proxyContract(eval(functionCall));
    };

    const packLambdaFunction = (tezos, governanceProxyContractAddress, lambdaFunction) => __awaiter(void 0, void 0, void 0, function* () {
        const governanceProxyInstance = yield tezos.contract.at(governanceProxyContractAddress);
        const param = governanceProxyInstance.methods.dataPackingHelper(lambdaFunction).toTransferParams();
        if (param.parameter) {
            const paramValue = param.parameter.value;
            const lambdaEntrypointType = yield governanceProxyInstance.entrypoints.entrypoints.dataPackingHelper;
            const packed = yield tezos.rpc.packData({
                data: paramValue,
                type: lambdaEntrypointType
            }).catch(e => console.error('error:', e));
            var packedParam;
            if (packed) {
                packedParam = packed.packed;
            }
            else {
                throw `packing failed`;
            }
        }
        return packedParam;
    });
    function getLigo(isDockerizedLigo, ligoVersion) {
        let path = 'ligo';
        if (isDockerizedLigo) {
            path = `docker run --platform=linux/amd64 -v $PWD:$PWD -w $PWD --rm -i mavrykdynamics/ligo:${ligoVersion}`;
            try {
                child_process.execSync(`${path}  --help`);
            }
            catch (err) {
                path = 'ligo';
                child_process.execSync(`${path}  --help`);
            }
        }
        else {
            try {
                child_process.execSync(`${path}  --help`);
            }
            catch (err) {
                path = `docker run --platform=linux/amd64 -v $PWD:$PWD -w $PWD --rm -i mavrykdynamics/ligo:${ligoVersion}`;
                child_process.execSync(`${path}  --help`);
            }
        }
        return path;
    }
    const compileLambdaFunctionContract = (contractPath = "", ligoVersion = "0.60.0m") => __awaiter(void 0, void 0, void 0, function* () {
        const ligo = getLigo(true, ligoVersion);
        const jsonFormat = child_process.execSync(`${ligo} compile contract ${contractPath} --michelson-format json --protocol lima`, {
            maxBuffer: 1024 * 1024,
            timeout: 1024 * 1024
        }).toString();
        // Get the lambda function from the compiled code
        return JSON.parse(jsonFormat)[2].args[0][1].args[0];
    });
    const getLambdaFunction = (rpc, governanceProxyContractAddress, lambdaFunctionName, lambdaFunctionParameters = []) => __awaiter(void 0, void 0, void 0, function* () {
        // Read the contents of the input file specified in the first command line argument
        const generatedContract = generateProxyContract(lambdaFunctionName, lambdaFunctionParameters);
        // Write the result to the output file
        const outputFile = __dirname + "/ligo/governanceProxyLambdaFunction.ligo";
        fs__namespace.writeFileSync(outputFile, generatedContract);
        // Start the compiling process
        const lambdaFunctionJson = yield compileLambdaFunctionContract(outputFile);
        const tezos = new taquito.TezosToolkit(rpc);
        const packedLambdaFunction = yield packLambdaFunction(tezos, governanceProxyContractAddress, lambdaFunctionJson);
        // Reset the file
        fs__namespace.writeFileSync(outputFile, "");
        return packedLambdaFunction;
    });

    (function compileLambdaFunction() {
        return __awaiter(this, void 0, void 0, function* () {
            const rpc = process.argv[2];
            const governanceProxyContractAddress = process.argv[3];
            const lambdaFunctionName = process.argv[4];
            var args = process.argv.slice(5);
            const lambdaFunctionParameters = args;
            if (!rpc || !governanceProxyContractAddress || !lambdaFunctionName) {
                return console.info("Usage: proposal-data-maker <rpc_url> <governance_proxy_contract_address> <lambda_function_name> <parameters...>");
            }
            // Turn strings into JSON in parameters
            for (let i = 0; i < args.length; i++) {
                try {
                    const fixedJSON = args[i].replace(/(['"])?([a-z0-9A-Z_]+)(['"])?:/g, '"$2": ');
                    const parsedParam = JSON.parse(fixedJSON);
                    args[i] = parsedParam;
                }
                catch (e) { }
            }
            // Get the lambda function
            const lambdaFunction = yield getLambdaFunction(rpc, governanceProxyContractAddress, lambdaFunctionName, lambdaFunctionParameters);
            console.log(lambdaFunction);
        });
    })();
    const createLambdaBytes = (rpc, governanceProxyContractAddress, lambdaFunctionName, lambdaFunctionParameters) => getLambdaFunction(rpc, governanceProxyContractAddress, lambdaFunctionName, lambdaFunctionParameters);

    exports.createLambdaBytes = createLambdaBytes;

}));
//# sourceMappingURL=create-lambda-bytes.umd.js.map
